/*================================================================*/
/*
* Parallel Recursive Spectral Bisection -
* Based on the sequential version provided by Horst Simon
* -ravi
*/
/*================================================================*/
#include <stdio.h>
#include "parti.h"

#define SIZE 100
/*
#define DEBUG
#include <util.h>
#define malloc(size)  NEWN(char, size)
#define free(ptr) DISPOSE(ptr)
*/

/*================================================================*/
/* renumber the CSR based on the distributed array color */
/* -ravi 07/13/91 */
/*****************************************************************/
/* IN: */
/* ttable: translation table for my_row_ptr                      */
/* lsched */
/* my_row_ind: */
/* my_row_ptr: */
/* my_col: */
/* localized_col: the indirection array  */
/* my_color: */
/* cur_color: */
/* ndata: */
/* ncol */
/* n_off_proc */
/* OUT: */
/* perm: a vector that maps current node no. to originial node # */
/* new_row_ind: */
/* new_row_ptr:
/* new_col: */
/* new_ncol: */
/* new_ndata */
/* teqns: current total number of nodes(points) after renumbering */
/*****************************************************************/
/*================================================================*/


renumber(ttable, lsched,  my_row_ind, my_row_ptr, my_col, localized_col, my_color, cur_color, ndata, ncol, n_off_proc,
perm, new_row_ind, new_row_ptr, new_col, new_ncol,new_ndata, teqns)

TTABLE *ttable;
SCHED *lsched;
int *my_col, *my_row_ptr, *my_row_ind;
int *localized_col;
int *my_color;
int cur_color;
int ndata, ncol, n_off_proc;
int **perm;
int **new_row_ptr,**new_col, **new_row_ind;
int *new_ncol,*new_ndata;
int *teqns;
{
   int i,j,k;
   int rcount, ccount;
   int *my_temp_row_ind;
   int *index;
   int prev_proc_count, next_proc_count;
   int *my_new_row_ptr,*my_new_col, *my_new_row_ind;
   int iwork, *local_size;
   int temp, temp2;

    
   /* get off processor color */
   index    = (int *) malloc(sizeof(int)*ndata);
     
   new_gather(lsched, &my_color[ndata], my_color, sizeof(int));

   /* find total number of new nodes(rcount) and coressponding
      adjacent nodes(ccount) for the current color */

   for(rcount=0,ccount=0,i=0; i<ndata; i++) {
     if (my_color[i] == cur_color) {
        index[rcount] = i;
        rcount++;
        for(j=my_row_ptr[i]; j<my_row_ptr[i+1]; j++) {
          if(my_color[localized_col[j]] == cur_color) {
             ccount++;
          }
        }
     }
   } 

   my_new_row_ind = (int *) malloc(sizeof(int)*rcount);
   my_new_row_ptr = (int *) malloc(sizeof(int)*(rcount+1));
   my_new_col     = (int *) malloc(sizeof(int)*ccount);
   local_size     = (int *) malloc(sizeof(int)*PARTI_numnodes);

   /* get global numbers for the current locals */
#ifdef MYDEBUG
   printf("\nrenumber: xlen=%d, ylen=%d, data=%d", sizeof(int), PARTI_numnodes*sizeof(int), rcount);
#endif
   PARTI_gcol(&rcount, sizeof(int), local_size, PARTI_numnodes*sizeof(int), &iwork); 
#ifdef MYDEBUG
   printf("\nrenumber: cnt=%d data(mine)= %d, data(off)= %d", iwork, *local_size, *(local_size+1));
#endif
   temp             = local_size[0];
    local_size[0]   = 0;
    for(i=1; i<PARTI_numnodes; i++) {
      temp2           = local_size[i];
      local_size[i]   =  temp;
      temp           += temp2;
   }
   for (i=0; i<rcount; i++) {
     my_new_row_ind[i] = local_size[PARTI_mynode] + i;
   }

   /* do the new row_ind numbering serially */
/*
   next_proc_count = prev_proc_count = 0;
   if (PARTI_mynode != 0 )  {
     PARTI_crecv(SIZE, &prev_proc_count, sizeof(int),PARTI_mynode-1,PARTI_pid);
   }
   if (PARTI_numnodes > 1 &&  PARTI_mynode != (PARTI_numnodes-1))  {
     next_proc_count = prev_proc_count + rcount;
     PARTI_csend(SIZE, &next_proc_count, sizeof(int), PARTI_mynode+1, 0);
   }
   for (i=0; i<rcount; i++) {
     my_new_row_ind[i] = prev_proc_count + i;
   }
*/
   my_temp_row_ind = (int *) malloc(sizeof(int)*(ndata+n_off_proc));
   for (i=0; i<(ndata+n_off_proc); i++) {
      my_temp_row_ind[i] = -1;
   }
   for (i=0; i<rcount; i++) {
      my_temp_row_ind[index[i]] = my_new_row_ind[i];
   }
   
   /* get the new node numbers (row_ind) for the adjacent nodes */

   new_gather(lsched, &my_temp_row_ind[ndata], my_temp_row_ind, sizeof(int));   

   for(rcount=0,ccount=0,i=0; i<ndata; i++) {
     if (my_color[i] == cur_color) {
       my_new_row_ptr[rcount++] = ccount;
       for(j=my_row_ptr[i]; j<my_row_ptr[i+1]; j++) {
          if (my_color[localized_col[j]] == cur_color) {
             my_new_col[ccount] = my_temp_row_ind[localized_col[j]];
             ccount++;
          }
       }
     }
   }
   my_new_row_ptr[rcount] = ccount;


   /* set out parameters */
   *new_ndata   = rcount;
   *new_ncol    = ccount;
   *new_row_ind = my_new_row_ind;
   *new_row_ptr = my_new_row_ptr;
   *new_col     = my_new_col;
   *perm        = index;
   PARTI_gisum(&rcount, 1, &iwork);
   *teqns = rcount;

   free(my_temp_row_ind);

}
/*================================================================*/
